import { Component, EventEmitter, inject, input, OnChanges, Output } from '@angular/core';
import { OrderEntity } from '../overview/order.component';
import { AlertErrorComponent } from '../../../shared/alert/alert-error.component';
import TranslateDirective from '../../../shared/language/translate.directive';
import SharedModule from '../../../shared/shared.module';
import { OfferedItemService } from '../../offered-item/service/offered-item.service';
import { combineLatest, filter, map, Observable, startWith, switchMap } from 'rxjs';
import { IOfferedItem } from '../../offered-item/offered-item.model';
import { NonNullableFormBuilder, ReactiveFormsModule, Validators } from '@angular/forms';
import { DataUtils } from '../../../core/util/data-util.service';
import { MatCard, MatCardContent, MatCardHeader, MatCardSubtitle, MatCardTitle } from '@angular/material/card';
import { MatIcon } from '@angular/material/icon';
import { MatPaginator, PageEvent } from '@angular/material/paginator';
import { MatFormField } from '@angular/material/form-field';
import { MatLabel, MatOption, MatSelect } from '@angular/material/select';

export enum ORDER_CONTROL {
  TITLE = 'title',
  AMOUNT = 'amount',
  PRICE = 'price',
  ITEM_ID = 'offeredItemID',
  ID = 'id',
}

@Component({
  selector: 'jhi-order-form',
  standalone: true,
  imports: [
    AlertErrorComponent,
    TranslateDirective,
    SharedModule,
    ReactiveFormsModule,
    MatCard,
    MatIcon,
    MatCardHeader,
    MatCardContent,
    MatCardSubtitle,
    MatCardTitle,
    MatPaginator,
    MatFormField,
    MatSelect,
    MatLabel,
    MatOption,
  ],
  templateUrl: './order-form.component.html',
  styleUrl: './order-form.component.scss',
})
export class OrderFormComponent implements OnChanges {
  @Output() abortOrder = new EventEmitter<void>();
  @Output() addOrPatchOrder = new EventEmitter<any>();
  formbuilder = inject(NonNullableFormBuilder);
  categoryControl = this.formbuilder.control<string | null>(null);
  isEditing = input.required<boolean>();
  entity = input<OrderEntity>();
  order = input<OrderEntity[] | undefined>();
  offeredItemService = inject(OfferedItemService);
  dataUtils = inject(DataUtils);
  offeredItems$!: Observable<IOfferedItem[]>;
  displayItems$!: Observable<IOfferedItem[]>;
  formGroup = inject(NonNullableFormBuilder).group({
    id: [0, Validators.required],
    amount: [0, [Validators.required, Validators.min(1)]],
    item: [<IOfferedItem | null>null, Validators.required],
  });
  length = 50;
  pageIndex = 0;

  selectedEntity$!: Observable<IOfferedItem | null>;
  categories$!: Observable<string[]>;

  get controls() {
    return this.formGroup.controls;
  }

  byteSize(base64String: string): string {
    return this.dataUtils.byteSize(base64String);
  }

  ngOnChanges() {
    this.formGroup.patchValue(this.entity()!);
    this.selectedEntity$ = this.controls.item.valueChanges.pipe(startWith(this.controls.item.value));
    this.offeredItems$ = combineLatest([
      this.offeredItemService.query().pipe(
        map(response => response.body),
        filter(itemList => !!itemList),
        map(itemList => {
          const order = this.order();
          let selectableEntities = itemList.filter(item => item.stock! > 0 && !item.hidden);
          if (order) {
            const orderIDs = order.map(order => order.item?.id);
            selectableEntities = selectableEntities.filter(entity => !orderIDs.includes(entity.id));
            if (this.isEditing()) {
              // @ts-expect-error Assumed correct because generated by JHipster
              selectableEntities.push(this.entity()?.item);
            }
          }
          return selectableEntities;
        }),
      ),
      this.selectedEntity$,
    ]).pipe(
      map(([selectableEntities, selectedEntity]) => {
        if (selectedEntity) return selectableEntities.filter(selectableEntity => selectableEntity.id !== selectedEntity.id);
        else return selectableEntities;
      }),
    );
    this.displayItems$ = this.offeredItems$.pipe(
      switchMap(entities =>
        this.categoryControl.valueChanges.pipe(
          startWith(this.categoryControl.value),
          map(filter => {
            if (filter) {
              return entities.filter(entity => entity.category === filter).slice(0, 9);
            } else return entities.slice(0, 9);
          }),
        ),
      ),
    );
    this.pageIndex = 0;
    this.getCategories();
  }

  handlePageEvent($event: PageEvent) {
    this.pageIndex = $event.pageIndex;

    this.displayItems$ = this.offeredItems$.pipe(
      switchMap(entities =>
        this.categoryControl.valueChanges.pipe(
          startWith(this.categoryControl.value),
          map(filter => {
            if (filter) {
              return entities
                .filter(entity => entity.category === filter)
                .slice($event.pageIndex * $event.pageSize, $event.pageIndex * $event.pageSize + $event.pageSize);
            } else return entities.slice($event.pageIndex * $event.pageSize, $event.pageIndex * $event.pageSize + $event.pageSize);
          }),
        ),
      ),
    );
  }

  selectEntity(displayItem: IOfferedItem) {
    this.controls.item.setValue(displayItem);
  }

  getCategories() {
    this.categories$ = this.offeredItems$.pipe(
      map(entities => {
        const categories = entities
          .map(entity => entity.category)
          .filter((category): category is string => category !== null && category !== undefined);
        return Array.from(new Set(categories));
      }),
    );
  }
}
